]> git.phdru.name Git - dotfiles.git/blobdiff - .shellrc
Fix(bin/cp_recode_fname): Fix misspelled message
[dotfiles.git] / .shellrc
index 67f9b762c91d7388eb23e8b99aa270b0996ec9dd..9f9242ae5e6a4d3d05448af6f06ceb2be68a222d 100644 (file)
--- a/.shellrc
+++ b/.shellrc
 # $HOME/.shellrc
 #
 
-OPS1="$OPS1\\$"
-PS1="$OPS1 "
-
-
-case "$SHELL" in
-*/bash)
-   [ "`type -t ls`" = alias ] && unalias ls
-   [ "`type -t ll`" = alias ] && unalias ll
-   [ "`type -t mc`" = alias ] && unalias mc
-
-   back() { cd - ${1:+"$@"}; }
-   clo() { clear; logout; }
-   eval 'functions() { typeset -f ${1:+"$@"}; }'
-   j() { jobs; }
-
-   if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
-      if [ "$SHELL" = /bin/bash ]; then
-         if [ -f /etc/bash_completion ]; then
-            . /etc/bash_completion
-         elif [ -d /etc/bash_completion.d ]; then
-            . /etc/bash_completion.d/*
-         fi
-      elif [ "$SHELL" = /usr/local/bin/bash ]; then
-         if [ -d /usr/local/etc/bash_completion.d ]; then
-            . /usr/local/etc/bash_completion.d/*
-         fi
-      else
-         echo "Unknown OS type, canot source bash_completion" >&2
-      fi
-   fi
-
-   has_completion() { return 0; }
-   if [ "$SHELL" = /bin/bash ]; then
-      if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
-         has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
-      fi
-   elif [ "$SHELL" = /usr/local/bin/bash ]; then
-      if [ -d /usr/local/etc/bash_completion.d ]; then
-         has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
-      fi
-   fi
-
-   for cmd in builtin cgmem_nice command dbus-launch exec \
-      killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
-      time whence whereis which xargs; do
-         ! has_completion $cmd && complete -o default -A command $cmd
-   done
-
-   for cmd in dig host nslookup nc netcat nmap p ping ping6 socat \
-      telnet t tt \
-      tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
-      whois wget wget-m wget-wrapper ww; do
-         ! has_completion $cmd && complete -A hostname $cmd
-   done
-
-   for cmd in distribute ftp lftp r rsync \
-      s scp ssh smbclient tcpdump tshark wireshark; do
-         ! has_completion $cmd && complete -o default -A hostname $cmd;
-   done
-
-   complete -A job bg fg j jobs wait
-   complete -A variable unset
-
-   if [ -d "$HOME/lib/config" ]; then
-      complete -W "`cd \"$HOME/lib/config\" && echo *`" include
-   fi
-   complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
-   ;;
-
-*/ksh)
-   back() { cd - ${1:+"$@"}; }
-   clo() { clear; exit; }
-   j() { jobs; }
-   ;;
-
-*/sh)
-   clo() { clear; exit; }
-   ;;
+# If not running interactively, don't do anything
+case $- in
+    *i*) ;;
+      *) return ;;
 esac
 
+# Stop if non-interactive shell
+[ -z "$PS1" ] && return
+
+#if [ -x /usr/bin/dircolors ]; then
+#   # I don't like these aliases - they work only in command line
+#   # but not in scripts I run from command line.
+#   # Color parameters must be passed via environment.
+#   # So instead I put them in shell scripts in ~/bin.
+#   alias ls='ls --color=auto'
+#   alias dir='dir --color=auto'
+#   alias vdir='vdir --color=auto'
+#
+#   alias grep='grep --color=auto'
+#   alias fgrep='fgrep --color=auto'
+#   alias egrep='egrep --color=auto'
+#
+#   alias dmesg='dmesg --human'
+#fi
+
+
+case "$HOME" in
+    /home/*)
+        if [ -L /home ]; then
+            START_DIR="`pwd`" &&
+            cd "$HOME" &&
+            HOME="`pwd`" &&
+            cd "$START_DIR"
+        fi
+    ;;
+esac
 
-# clear history, clear screen and logout
-#chlo() { cd; unset HISTFILE; rm -f .*history*; clo; }
-
+if test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
+    back() { cd - "$@"; }
+    j() { jobs; }
+fi
+
+# clear screen and history, logout
+chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
+
+if [ -n "$STY" -a "$WINDOW" != 0 ]; then
+    #unset MAILCHECK everywhere except for the 1st GNU screen window
+    unset MAILCHECK
+fi
+
+if test -x /usr/bin/git >/dev/null 2>&1; then
+    # chdir to a directory
+    cdgitpath() {
+        if [ $# -ne 1 ]; then
+            echo "Usage: cdgitpath path_key" >&2
+            return 1
+        fi
+
+        path_key="$1"
+        if [ -z "$path_key" ]; then
+            echo "Usage: cdgitpath path_key" >&2
+            return 1
+        fi
+
+        path_url="`git config --get --path $path_key`"
+        if echo "$path_url" | grep -q '^file:/'; then
+            path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
+        fi
+        cd "$path_url"
+    }
+
+    # See https://stackoverflow.com/a/77266926/7976758
+
+    cd_worktree() {
+        if [ $# -ne 1 ]; then
+            echo "Usage: cd_worktree <branch>" >&2
+            return 1
+        fi
+        path="$(git worktree list | grep -F "$1" | awk '{print $1}')"
+        if [ -n "$path" ]; then
+            cd "$path"
+        else
+            echo "Cannot find path for branch '$1'" >&2
+            return 1
+        fi
+    }
+fi
+
+include() {
+    cfg="$1"
+    shift
+    if [ -f "./$cfg" -a -r "./$cfg" ]; then
+        echo "Reading config file \`$cfg'" 1>&2
+        . "./$cfg" "$@"
+    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
+        echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
+        . "$HOME/lib/config/$cfg" "$@"
+    else
+        echo "Cannot find config file \`$cfg'" 1>&2
+    fi
+}
 
-#Pwd() { pwd | sed "s/.*\/\(.*\)\/\(.*\)\/\(.*\)\/\(.*\)/...\/\2\/\3\/\4/"; }
-#PWd() { pwd | sed "s/.*\/\(.*\)\/\(.*\)/...\/\2/"; }
 
+[ "`type -t mc`" = alias ] && unalias mc
+mc() {
+    if [ -n "$SLOWTERM" ]; then
+        MC_SLOW="--slow"
+    fi
+
+    case "$TERM" in
+        screen*) # screen, screen.rxvt
+            MC_XTERM="-x"
+        ;;
+    esac
+
+    #TMPDIR="$HOME"/tmp
+    #export TMPDIR
+
+    MC_FOUND=NO
+
+    for wrapper in \
+            /usr/local/share/mc/bin/mc-wrapper.sh \
+            /usr/local/libexec/mc/mc-wrapper.sh \
+            /usr/share/mc/bin/mc-wrapper.sh; do
+        if [ -r $wrapper ]; then
+            . $wrapper $MC_SLOW $MC_XTERM "$@"
+            rc=$?
+            MC_FOUND=YES
+            break
+        fi
+    done
+
+    if [ $MC_FOUND = NO ]; then
+        for mc in /usr/local/bin/mc /usr/bin/mc; do
+            if [ -x $mc ]; then
+                MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
+                if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
+                    MC_TMP_DIR="${TMPDIR-/tmp}"
+                fi
+                MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
+                mc_type="`mc_type.py $mc`"
+                if [ "$mc_type" = old ]; then
+                    $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
+                elif [ "$mc_type" = new ]; then
+                    $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
+                else
+                    continue
+                fi
+                rc=$?
+                MC_FOUND=YES
+                cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
+                break
+            fi
+        done
+    fi
 
-psg()   { ps auxw   | grep -i ${1:+"$@"} | grep -v '\(ps auxw\|grep\)'; }
-pswg()  { ps auxwww | grep -i ${1:+"$@"} | grep -v '\(ps auxw\|grep\)'; }
+    if [ $MC_FOUND = NO ]; then
+        echo "Cannot find mc-wrapper.sh or mc" >&2
+        rc=1
+    fi
 
-# Like pgrep -f
-pidOf() { ps auxwww | grep -i ${1:+"$@"} | grep -v '\(ps auxw\|grep\|pidOf\|KillAll\)' | awk '{print $2}'; }
+    unset wrapper MC_FOUND MC_PWD_FILE MC_SLOW MC_TMP_DIR MC_XTERM
 
-# A kind of pkill/killall
-KillAll() {
-   if [ -z "$2" ]; then
-      kill `pidOf "$1"`
-   else
-      kill "$1" `pidOf "$2"`
-   fi
+    return $rc
 }
 
 
-x() { exit; }
-X() { startx >> .Xserver.log 2>&1; cyr; }
-
-
-include()
-{
-   cfg="$1"
-   if [ -f "./$cfg" -a -r "./$cfg" ]; then
-      echo "Reading config file \`$cfg'" 1>&2
-      . "./$cfg"
-   elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
-      echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
-      . "$HOME/lib/config/$cfg"
-   else
-      echo "Cannot find config file \`$cfg'" 1>&2
-   fi
+mkcd() {
+    if [ $# -ne 1 ]; then
+        echo "Usage: mkcd directory_name" >&2
+    elif [ -d "$1" ]; then
+        cd "$1"
+    elif [ -e "$1" ]; then
+        echo "Error: $1 is a file" >&2
+    else
+        mkdir -p "$1" && cd "$1"
+    fi
 }
 
 
-mc() {
-   if [ -n "$SLOWTERM" ]; then
-      MC_SLOW="--slow"
-   fi
-
-   case "$TERM" in
-      screen*) # screen, screen.rxvt
-         if [ "$TERM" = screen.rxvt ]; then
-            MC_SAVE_TERM="$TERM"
-            TERM=rxvt
-         fi
-         MC_XTERM="-x"
-      ;;
-   esac
-
-   #TMPDIR="$HOME"/tmp
-   #export TMPDIR
-
-   MC_FOUND=NO
-
-   for wrapper in \
-         /usr/local/share/mc/bin/mc-wrapper.sh \
-         /usr/local/libexec/mc/mc-wrapper.sh \
-         /usr/share/mc/bin/mc-wrapper.sh; do
-      if [ -r $wrapper ]; then
-         . $wrapper $MC_SLOW $MC_XTERM "$@"
-         rc=$?
-         MC_FOUND=YES
-         break
-      fi
-   done
-
-   if [ $MC_FOUND = NO ]; then
-      for mc in /usr/local/bin/mc /usr/bin/mc; do
-         if [ -x $mc ]; then
-            MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
-            if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
-               MC_TMP_DIR="${TMPDIR-/tmp}"
-            fi
-            MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
-            mc_type="`mc_type.py $mc`"
-            if [ "$mc_type" = old ]; then
-               $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
-            elif [ "$mc_type" = new ]; then
-               $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
-            else
-               continue
-            fi
-            rc=$?
-            MC_FOUND=YES
-            cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
-            break
-         fi
-      done
-   fi
-
-   if [ $MC_FOUND = NO ]; then
-      echo "Cannot find mc-wrapper.sh or mc" >&2
-      rc=1
-   fi
-
-   [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
-   unset MC_FOUND MC_PWD_FILE MC_SAVE_TERM MC_SLOW MC_TMP_DIR MC_XTERM
-   return $rc
-}
+if which tmux >/dev/null 2>&1; then
+    tmux() {
+        case "$TERM" in
+            rxvt)
+                TERM=rxvt-unicode command tmux "$@"
+            ;;
 
+            *)
+                command tmux "$@"
+            ;;
+        esac
+    }
+fi
 
-tmux() {
-   case "$TERM" in
-      rxvt)
-         TERM=rxvt-unicode command tmux "$@"
-      ;;
 
-      *)
-         command tmux "$@"
-      ;;
-   esac
+vim() {
+    command vim "$@"
+    rc=$?
+    cd "`cat \"$HOME/tmp/vim/cwd\"`" && /bin/rm "$HOME/tmp/vim/cwd" &&
+    return $rc
 }
+
+
+if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
+    X() { startx >> .Xserver.log 2>&1; cyr; /bin/rm -f .Xauthority; }
+fi
+
+x() { exit; }